From: Antonio Quartulli <antonio@meshcoding.com>
Date: Sat, 31 Oct 2015 10:30:54 +0100
Subject: [PATCH] batman-adv: kerneldoc TODO Antonio Quartulli <antonio@meshcoding.com>
---
 net/batman-adv/distributed-arp-table.c |  4 ++++
 net/batman-adv/translation-table.c     | 21 ++++++++++++++++-----
 net/batman-adv/types.h                 |  2 ++
 3 files changed, 22 insertions(+), 5 deletions(-)

diff --git a/net/batman-adv/distributed-arp-table.c b/net/batman-adv/distributed-arp-table.c
index 9daccdc..496ada2 100644
--- a/net/batman-adv/distributed-arp-table.c
+++ b/net/batman-adv/distributed-arp-table.c
@@ -738,6 +738,8 @@ static void batadv_dat_hash_free(struct batadv_priv *bat_priv)
 /**
  * batadv_dat_init - initialise the DAT internals
  * @bat_priv: the bat priv with all the soft interface information
+ *
+ * Return: TODO
  */
 int batadv_dat_init(struct batadv_priv *bat_priv)
 {
@@ -776,6 +778,8 @@ void batadv_dat_free(struct batadv_priv *bat_priv)
  * batadv_dat_cache_seq_print_text - print the local DAT hash table
  * @seq: seq file to print on
  * @offset: not used
+ *
+ * Return: TODO
  */
 int batadv_dat_cache_seq_print_text(struct seq_file *seq, void *offset)
 {
diff --git a/net/batman-adv/translation-table.c b/net/batman-adv/translation-table.c
index d98476f..a49e9b4 100644
--- a/net/batman-adv/translation-table.c
+++ b/net/batman-adv/translation-table.c
@@ -69,7 +69,9 @@ static void batadv_tt_global_del(struct batadv_priv *bat_priv,
 				 bool roaming);
 
 /**
- * batadv_compare_tt
+ * batadv_compare_tt - TODO
+ * @node: TODO
+ * @data2: TODO
  *
  * Return: 1 if they are the same mac addr
  */
@@ -219,6 +221,7 @@ batadv_tt_global_entry_free_ref(struct batadv_tt_global_entry *tt_global_entry)
 
 /**
  * batadv_tt_global_hash_count - count the number of orig entries
+ * @bat_priv: the bat priv with all the soft interface information
  * @addr: the mac address of the client to count entries for
  * @vid: VLAN identifier
  *
@@ -303,6 +306,7 @@ static void batadv_tt_local_size_dec(struct batadv_priv *bat_priv,
 /**
  * batadv_tt_global_size_mod - change the size by v of the local table
  *  identified by vid
+ * @orig_node: TODO
  * @vid: the VLAN identifier
  * @v: the amount to sum to the global table size
  */
@@ -721,7 +725,6 @@ out:
  *  function reserves the amount of space needed to send the entire global TT
  *  table. In case of success the value is updated with the real amount of
  *  reserved bytes
-
  * Allocate the needed amount of memory for the entire TT TVLV and write its
  * header made up by one tvlv_tt_data object and a series of tvlv_tt_vlan_data
  * objects, one per active VLAN served by the originator node.
@@ -1243,7 +1246,9 @@ static void batadv_tt_changes_list_free(struct batadv_priv *bat_priv)
 }
 
 /**
- * batadv_tt_global_orig_entry_find
+ * batadv_tt_global_orig_entry_find - TODO
+ * @entry: TODO
+ * @orig_node: TODO
  *
  * retrieves the orig_tt_list_entry belonging to orig_node from the
  * batadv_tt_global_entry list
@@ -1274,7 +1279,9 @@ batadv_tt_global_orig_entry_find(const struct batadv_tt_global_entry *entry,
 }
 
 /**
- * batadv_tt_global_entry_has_orig
+ * batadv_tt_global_entry_has_orig - TODO
+ * @entry: TODO
+ * @orig_node: TODO
  *
  * find out if an orig_node is already in the list of a tt_global_entry.
  *
@@ -2519,6 +2526,8 @@ static void batadv_tt_global_update_crc(struct batadv_priv *bat_priv,
  * @num_vlan: number of tvlv VLAN entries
  * @full_table: ask for the entire translation table if true, while only for the
  *  last TT diff otherwise
+ *
+ * Return: TODO
  */
 static int batadv_send_tt_request(struct batadv_priv *bat_priv,
 				  struct batadv_orig_node *dst_orig_node,
@@ -3062,7 +3071,9 @@ static void batadv_tt_roam_purge(struct batadv_priv *bat_priv)
 }
 
 /**
- * batadv_tt_check_roam_count
+ * batadv_tt_check_roam_count - TODO
+ * @bat_priv: the bat priv with all the soft interface information
+ * @client: mac address of the roaming client
  *
  * This function checks whether the client already reached the
  * maximum number of possible roaming phases. In this case the ROAMING_ADV
diff --git a/net/batman-adv/types.h b/net/batman-adv/types.h
index 7f7a0f1..1a450ac 100644
--- a/net/batman-adv/types.h
+++ b/net/batman-adv/types.h
@@ -772,6 +772,8 @@ struct batadv_softif_vlan {
  * @orig_interval: OGM broadcast interval in milliseconds
  * @hop_penalty: penalty which will be applied to an OGM's tq-field on every hop
  * @log_level: configured log level (see batadv_dbg_level)
+ * @isolation_mark: TODO
+ * @isolation_mark_mask: TODO
  * @bcast_seqno: last sent broadcast packet sequence number
  * @bcast_queue_left: number of remaining buffered broadcast packet slots
  * @batman_queue_left: number of remaining OGM packet slots